#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);
    int n, k, x;
    cin >> n >> k >> x;
    x--;
    long long a[n];
    long long prefiksni[n + 1];
    prefiksni[0] = 0;
    bool nenegativni = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] < 0)
            nenegativni = false;
        prefiksni[i + 1] = prefiksni[i] + a[i];
    }
    if (nenegativni) {
        long long s = 0;
        for (int i = 0; i <= x; i++)
            s += prefiksni[k] - prefiksni[i];
        cout << s << ' ';
        for (int i = k; i < n; i++) {
            s -= prefiksni[i] - prefiksni[i - k];
            s += prefiksni[i + 1] - prefiksni[i - k + x + 1];
            s += x * a[i];
            cout << s << ' ';
        }
        cout << '\n';
        return 0;
    }
    for (int j = k - 1; j < n; j++) {
        vector<long long> zbirovi(k);
        long long s = 0;
        for (int i = 0; i < k - 1; i++) {
            s += a[j - i];
            zbirovi[i] = s;
        }
        zbirovi[k - 1] = 0;
        sort(zbirovi.begin(), zbirovi.end());
        long long vrednost = prefiksni[j + 1] - prefiksni[j - k + 1];
        for (int i = 0; i < x; i++)
            vrednost += zbirovi[k - 1 - i];
        cout << vrednost << ' ';
    }
    cout << '\n';
    return 0;
}